import math
import matplotlib.pyplot as mpt

def sqr(x):
    return x * x

#
#       Prepare the input data file
#
s_in = input("Input data file = ")
f_in = open(s_in, "r")
#
#       Set the contents of the input data file in the object data 
#
data_f = f_in.readlines()
f_in.close()
#
#       Prepare the output file
#
s_out = input("Output data file = ")
f_out = open(s_out, "w")
f_out.write("Input data file = " + s_in + "\n\n")

pos = 0
while True:
    if data_f[pos].find("/", 0) == 0: break     #   Jump to teh first line with slash at the head
    pos += 1
            
n = 0
pairs = []
while True:
    pos += 1
    if data_f[pos].find("/", 0) == 0: break     #   Exit when the line with slash at the head is met
    #
    #       Add the data
    #
    temp_s = data_f[pos].split()
    pairs.append([])
    pairs[n].append(float(temp_s[0]))
    pairs[n].append(float(temp_s[1]))
    n += 1

f_out.write("\n")
f_out.write("The number of pairs = %d\n"%n)
f_out.write("Data...\n")
i = 1
for v in pairs:
    f_out.write("%5d:  %f  %f\n"%(i, v[0], v[1]))
    i += 1

sum_x = 0.0
sum_y = 0.0
for i in range(0, n):
    sum_x += pairs[i][0]
    sum_y += pairs[i][1]
mean_x = sum_x / n
mean_y = sum_y / n
print("Mean_x = %f"%mean_x)
print("Mean_y = %f"%mean_y)
f_out.write("\nMean_x = %f\n"%mean_x)
f_out.write("Mean_y = %f\n"%mean_y)

ssum_x = 0.0
ssum_y = 0.0
sum_xy = 0.0
for i in range(0, n):
    ssum_x += sqr(pairs[i][0] - mean_x)
    ssum_y += sqr(pairs[i][1] - mean_y)
    sum_xy += (pairs[i][0] - mean_x) * (pairs[i][1] - mean_y)

var_x = ssum_x / n                  #   Variance of X
var_y = ssum_y / n                  #   Variance of Y
print("Var_x = %f"%var_x)
print("Var_y = %f"%var_y)
f_out.write("Var_x = %f\n"%var_x)
f_out.write("Var_y = %f\n"%var_y)
sd_x = math.sqrt(var_x)             #   Standard deviation of X
sd_y = math.sqrt(var_y)             #   Standard deviation of Y
print("sd_x = %f"%sd_x)
print("sd_y = %f"%sd_y)
f_out.write("sd_x = %f\n"%sd_x)
f_out.write("sd_y = %f\n"%sd_y)
cor = sum_xy / math.sqrt(ssum_x * ssum_y)   #   The correlation coefficient
print("r = %f"%cor)
f_out.write("r = %f\n"%cor)


data_x = []     #   Values of the coordinate Xs of the pairs
data_y = []     #   Values of the coordinate Ys of the pairs
for i in range(0, n):
    data_x.append(pairs[i][0])
    data_y.append(pairs[i][1])
print(data_x)
print(data_y)

f_out.close()
print("Output file " + s_out + " was saved.") 

mpt.title("Scattergram...r = %6.3f"%cor)
mpt.xlabel("Weight")
mpt.ylabel("Height")
mpt.plot(data_x, data_y, 'g^')      #   'g^' -> green triangle
mpt.show()

    
