import scipy.stats as ss
import matplotlib.pyplot as plt

d_r0 = ss.multivariate_normal.rvs([0, 0], [[1, 0], [0, 1]], size = 100)
d_r09 = ss.multivariate_normal.rvs([0,0], [[1, 0.9], [0.9, 1]], size = 100)

plt.rcParams['font.family'] = 'Yu Gothic'

plt.figure(figsize = (7, 7))
plt.title('散布図', fontsize = 30)
plt.plot(d_r0[:,0], d_r0[:, 1], 'go', label = '相関係数 = 0')
plt.plot(d_r09[:, 0], d_r09[:, 1], 'bo', label = '相関係数 = 0.9')
plt.xlabel('X軸', fontsize = 20)
plt.ylabel('Y軸', fontsize = 20)
plt.xlim(-3.5, 3.5)
plt.ylim(-3.5, 3.5)
plt.legend(loc = 'lower right', fontsize = 16)
plt.show()
